<?
echo "<hr />";
echo "<b>pre-fork (buffer before fork)</b><br />\n";
echo "posix_getpid()=".posix_getpid().", posix_getppid()=".posix_getppid()."<br />\n";

if ($_SERVER["SONIC_WWW_SELF"])
{
//send buffer reset
  //C-L = any then sonic/WWW will _NOT_ send C-L
  $_SERVER["SONIC_WWW_SELF"]->header("Content-Length: any");

  //incase forks are slow
  $_SERVER["SONIC_WWW_SELF"]->header("Connection: Keep-Alive"); 

  //really _not_ for http/1.0 but better than sending no C-L
  $_SERVER["SONIC_WWW_SELF"]->header("Transfer-Encoding: identity"); 

  //trigger header sent now (so forks dont send headers each)
  $_SERVER["SONIC_WWW_SELF"]->sonic_www_echo($_SERVER["SONIC_WWW_SELF"]->http_response_code, $_SERVER["SONIC_WWW_SELF"]->http_buffer);//.ob_get_contents());
}

$pid = pcntl_fork();

//parent->pid = child_pid
//child->pid  = 0

//forked up until this point therefore the above will echo twice

if ($pid == -1)
{
  if ($_SERVER["SONIC_WWW_SELF"])
  {
    $_SERVER["SONIC_WWW_SELF"]->php_exit("could not fork");
  }
  else
    die("could not fork");
}

echo "<b>post-fork (buffer since fork)</b><br />\n";

if ($pid)
{
    echo "<b>fork-left / parent</b><br />\n";

    if ($_SERVER["SONIC_WWW_SELF"])
    {
      $_SERVER["SONIC_WWW_SELF"]->pid_child = $pid; //play nice (dont have to)
      echo "swww_pid=".$_SERVER["SONIC_WWW_SELF"]->pid.", ";
    }

    echo "(child) pid=".$pid.", posix_getpid()=".posix_getpid().", posix_getppid()=".posix_getppid()."<br />\n";
}
else
{
    echo "<b>fork-right / child</b><br />\n";

    if ($_SERVER["SONIC_WWW_SELF"])
    {
      $_SERVER["SONIC_WWW_SELF"]->pid_child = posix_getpid(); //play nice (dont have to)
      echo "swww_pid=".$_SERVER["SONIC_WWW_SELF"]->pid.", ";
    }

    echo "(child->child) pid=".$pid.", posix_getpid()=".posix_getpid().", posix_getppid()=".posix_getppid()."<br />\n";
}

?>
